using System.Runtime.InteropServices;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
namespace CSharpTest
{
    public partial class Form1 : Form
    {
        [DllImport("LL_USB2k.dll")] public static extern byte EX_Connect(ushort[] usDevID);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_SetPolledModeChan(ushort usDevID, byte bChan);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_GetOneConversion(ushort usDevID, double[] pdblMilliVolts);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_SendDigout(ushort usDevID, byte bDigOut);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_GetDigin(ushort usDevID, byte[] pbDigIn);

        [DllImport("LL_USB2k.dll")] public static extern byte EX_SetScanType(ushort usDevID, byte bScanType);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_SetMultiChanScanChans(ushort usDevID, byte bChanCnt);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_SetDataLogOptions(ushort usDevID, UInt32 uiDataLogMethod, UInt32 uiLogFileMaxSize, UInt32 uiMisc);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_CheckScanStatus(ushort usDevID, UInt32[] puiNumScansRemainingInBuff, byte[] pfStillScanning, UInt32[] puiStatusCode);
        [DllImport("LL_USB2k.dll")] public static extern byte 
            EX_GetScanDataDbl(ushort usDevID, double[] pdblDataBuff, UInt32 uiNumScansToReturn, 
            byte fGetAllRequested, UInt32[] puiNumScansReturned, UInt32[] puiNumScansRemainingInBuff, 
            byte[] pfStillScanning, UInt32[] puiTotalBuffSize, UInt32[] puiStatusCode);

        [DllImport("LL_USB2k.dll")] public static extern byte 
            EX_GetScanDataDblDigin(ushort usDevID, double[] pdblDataBuff, byte[] pbDiginBuff,
            UInt32 uiNumScansToReturn, byte fGetAllRequested, UInt32[] puiNumScansReturned,
            UInt32[] puiNumScansRemainingInBuff, byte[] pfStillScanning, UInt32[] puiTotalBuffSize, 
            UInt32[] puiErrCode); 

        [DllImport("LL_USB2k.dll")] public static extern byte EX_Run(ushort usDevID);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_Stop(ushort usDevID);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_StopComplete(ushort usDevID);
        ushort[] pusDevID = new ushort[1];
        Byte bRetVal;
        Thread MyThread = null;
        Boolean fMyThreadActive = false;
        Boolean fEndScan = false;
        Boolean fScanRunning = false;
        int uiFormWidth = 0;
        int uiFormHeight = 0;
        Point frmSize = new Point(0, 0);


        byte bThreadCommand = 0;
        const byte THREAD_DO_CONNECT = 1;
        const byte THREAD_DO_END_SCAN = 2;

        const byte MULTI_CHAN_SCAN = 2;
        const byte MULTI_CHAN_DIGIN_SCAN = 5;
        const ushort SCAN_USE_DATA_ARRAY = 2; 
        public Form1() { InitializeComponent(); }

        //disable the close button
        //private const int CP_NOCLOSE_BUTTON = 0x200;
        //protected override CreateParams CreateParams
        //{ get { CreateParams myCp = base.CreateParams; myCp.ClassStyle = myCp.ClassStyle | CP_NOCLOSE_BUTTON; return myCp; } }




        private void MyThreadFunc()
        {
            fMyThreadActive = true; grpBoxCover.Visible = true; grpBoxCover.Location = new Point(11, 9);

            if (bThreadCommand == THREAD_DO_CONNECT)
            {
                btnExConnect.Enabled = false; btnGetOneConv.Enabled = false;
                btnStartScan.Enabled = false; btnStopScan.Enabled = false;
                btnDigOut.Enabled = false; btnDigIn.Enabled = false;
                btnClose.Enabled = false; 
                bRetVal = EX_Connect(pusDevID);
                if (bRetVal == 1)
                {
                    txtDevID.Text = string.Format("{0:D}", pusDevID[0]);
                    btnGetOneConv.Enabled = true;
                    toolStripStatusLabel1.Text = "connect SUCCESS";
                }
                else
                {
                    txtDevID.Text = "failed"; btnGetOneConv.Enabled = false;
                    toolStripStatusLabel1.Text = "connect FAILED";
                }
                btnExConnect.Enabled = true; btnGetOneConv.Enabled = true;
                btnStartScan.Enabled = true; //btnStopScan.Enabled = true;
                btnDigOut.Enabled = true; btnDigIn.Enabled = true;
                btnClose.Enabled = true; 
            }
            if (bThreadCommand == THREAD_DO_END_SCAN)
            {
                fEndScan = false;
                EX_Stop(pusDevID[0]);
                EX_StopComplete(pusDevID[0]);
                toolStripStatusLabel1.Text = "scan ended";
                fScanRunning = false;

                btnExConnect.Enabled = true; btnGetOneConv.Enabled = true;
                btnStartScan.Enabled = true;
                btnStopScan.Enabled = false;
                btnDigOut.Enabled = true;
                btnDigIn.Enabled = true;
                btnClose.Enabled = true;
            }
            grpBoxCover.Visible = fMyThreadActive = progressBar1.Visible = false;
            toolStripProgressBar1.Visible = false;
            return;
        }
        private void btnConnect_Click(object sender, EventArgs e)
        {
            bThreadCommand = THREAD_DO_CONNECT;
            //toolStripProgressBar1.Style = ProgressBarStyle.Marquee;
            toolStripProgressBar1.Visible = true;
            toolStripStatusLabel1.Text = "  connecting . . . . .";

            progressBar1.Visible = true;
            toolStripProgressBar1.MarqueeAnimationSpeed = 80;

            MyThread = new Thread(new ThreadStart(MyThreadFunc));
            MyThread.Priority = ThreadPriority.Normal; MyThread.Start();
            Application.DoEvents(); Update();
            return;
        }
        private void btnGetOneConv_Click(object sender, EventArgs e)
        {
            double[] dblMilliVolts = new double[1]; 
            toolStripStatusLabel1.Text = "  wait";

            if (EX_GetOneConversion(pusDevID[0], dblMilliVolts) == 1)
            {
                txtGetConvVolts.Text = string.Format("{0:f6}", dblMilliVolts[0] / 1000);
                toolStripStatusLabel1.Text = "  get voltage SUCCESS";
            }
            else toolStripStatusLabel1.Text = "  get voltage FAILED";
            return;
        }
        private void btnDigOut_Click(object sender, EventArgs e)
        {
            if (txtDigOut.Text.Length == 0) txtDigOut.Text = "0";
            if ((byte)int.Parse(txtDigOut.Text) > 255) txtDigOut.Text = "255";
            byte bDig = (byte)int.Parse(txtDigOut.Text);
            if (EX_SendDigout(pusDevID[0], (byte)int.Parse(txtDigOut.Text)) == 1)
            { toolStripStatusLabel1.Text = "  send digital output SUCCESS"; }
            else toolStripStatusLabel1.Text = "  send digital output FAILED";

        }
        private void btnDigIn_Click(object sender, EventArgs e)
        {
            byte[] bDigIn = new byte[1];
            if (EX_GetDigin(pusDevID[0], bDigIn) == 1)
            {
                txtDigIn.Text = string.Format("{0}", bDigIn[0]);
                toolStripStatusLabel1.Text = "  get digital input SUCCESS";
            }
            else toolStripStatusLabel1.Text = "  get digital input FAILED";
        }
        private void btnStartScan_Click(object sender, EventArgs e)
        {
            byte[] pfStillScanning = new byte[1];
            byte fGetAllRequested;
            uint uiScanCnt = 0;

            double[] dblDataBuff = new double[20];  //2-chan scan = 10 scans worth of space for data
            byte[] dblDiginBuff = new byte[20];     //2-chan scan = 10 scans worth of space for digin
            UInt32[] puiNumScansRemainingInBuff = new UInt32[1];
            UInt32[] puiStatusCode = new UInt32[1]; puiStatusCode[0] = 0;
            UInt32 []puiNumScansReturned = new UInt32[1];
            UInt32[] puiTotalBuffSize = new UInt32[1]; puiTotalBuffSize [0]= 20;  
            UInt32 uiNumScansToReturn;
            toolStripStatusLabel1.Text = "  starting - please wait . . . .";
            toolStripProgressBar1.Visible = true;
            Update();
            if (EX_SetScanType(pusDevID[0], MULTI_CHAN_DIGIN_SCAN) == 0) { toolStripStatusLabel1.Text = "EX_SetScanType() failed"; return; }
            if (EX_SetMultiChanScanChans(pusDevID[0], 2) == 0) { toolStripStatusLabel1.Text = "EX_SetMultiChanScanChans() failed"; return; }
            if (EX_SetDataLogOptions(pusDevID[0], SCAN_USE_DATA_ARRAY, 0, 0) == 0) { toolStripStatusLabel1.Text = "EX_SetDataLogOptions() failed"; return; }
            if (EX_Run(pusDevID[0]) == 0) { toolStripStatusLabel1.Text = "EX_Run() failed"; return; }
            toolStripStatusLabel1.Text = "  SCAN startup success";
            toolStripProgressBar1.Visible = false;
            Update();
            fScanRunning = true;

            btnExConnect.Enabled = false; btnGetOneConv.Enabled = false;
            btnStartScan.Enabled = false; 
            btnStopScan.Enabled = true;
            btnDigOut.Enabled = false; btnDigIn.Enabled = false;
            btnClose.Enabled = false; 

            while (true)
            {
                if (fEndScan) break;
                EX_CheckScanStatus(pusDevID[0], puiNumScansRemainingInBuff, pfStillScanning, 
                    puiStatusCode);
                Application.DoEvents();
                if (puiNumScansRemainingInBuff[0] > 0)
                {
                    txtScansInBuff.Text = string.Format("{0}", puiNumScansRemainingInBuff[0]);
                    uiNumScansToReturn = puiNumScansRemainingInBuff[0];
                    if (uiNumScansToReturn >= 9) uiNumScansToReturn = 9;
                    EX_GetScanDataDblDigin(pusDevID[0], dblDataBuff, dblDiginBuff, uiNumScansToReturn, 0, 
                        puiNumScansReturned, puiNumScansRemainingInBuff, pfStillScanning, puiTotalBuffSize, 
                        puiStatusCode); 

                    for (byte bCnt = 0; bCnt < uiNumScansToReturn; bCnt++)
                    {
                        uiScanCnt++;
                        txtScanNum.Text = string.Format("{0}", uiScanCnt);
                        txtScanStatus.Text = string.Format("{0:X}", puiStatusCode[0]);
                        txtChan0.Text = string.Format("{0:f6}", dblDataBuff[bCnt]);
                        txtChan1.Text = string.Format("{0:f6}", dblDataBuff[bCnt + 1]);
                        txtChan0Digin.Text = string.Format("{0}", dblDiginBuff[bCnt]);
                        txtChan1Digin.Text = string.Format("{0}", dblDiginBuff[bCnt]);
                        
                        Application.DoEvents(); Update();
                    }
                }
                Application.DoEvents();
            }
            bThreadCommand = THREAD_DO_END_SCAN;
            toolStripProgressBar1.Visible = true;
            toolStripStatusLabel1.Text = "  ending scan . . . . .";

            progressBar1.Visible = true;
            toolStripProgressBar1.MarqueeAnimationSpeed = 80;

            MyThread = new Thread(new ThreadStart(MyThreadFunc));
            MyThread.Priority = ThreadPriority.Normal; MyThread.Start();
            Application.DoEvents(); Update();
            return;
        }
        private void btnStopScan_Click(object sender, EventArgs e)
        { fEndScan = true; return; }

        private void Form1_Load(object sender, EventArgs e)
        { toolStripProgressBar1.Visible = false; }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (fScanRunning)
            {
                bThreadCommand = THREAD_DO_END_SCAN;
                toolStripProgressBar1.Visible = true;
                toolStripStatusLabel1.Text = "  ending scan . . . . .";

                progressBar1.Visible = true;
                toolStripProgressBar1.MarqueeAnimationSpeed = 80;

                MyThread = new Thread(new ThreadStart(MyThreadFunc));
                MyThread.Priority = ThreadPriority.Normal; MyThread.Start();
                Application.DoEvents(); Update();
                while (fScanRunning) Application.DoEvents();
            }
            //if (fMyThreadActive) if (MyThread.IsAlive) MyThread.Abort();
        }

        private void txtDigOut_KeyPress(object sender, KeyPressEventArgs e)
        { const char Delete = (char)8; e.Handled = !Char.IsDigit(e.KeyChar) && e.KeyChar != Delete; }

        private void btnClose_Click(object sender, EventArgs e)
        {  Application.Exit(); }

        private void Form1_Resize(object sender, EventArgs e)
        { Form1.ActiveForm.Size = new Size(uiFormWidth, uiFormHeight); }

        private void Form1_Activated(object sender, EventArgs e)
        { uiFormWidth = Form1.ActiveForm.Size.Width; uiFormHeight = Form1.ActiveForm.Size.Height; }
    }
}


//progress bar experiments
//toolStripProgressBar1.Style = ProgressBarStyle.Blocks;
//toolStripProgressBar1.ProgressBar.Value = 100;
//toolStripProgressBar1.ProgressBar.Step = 0;
//toolStripProgressBar1.Step = 0;
//toolStripProgressBar1.Value = 0;
//toolStripProgressBar1.Maximum = 0;







